Attribute VB_Name = "SharedVar"
Option Explicit

'true if mouse if down on tileset/map/radar
Global MouseDown As Boolean

Global bDEBUG As Boolean

Global Const TileW = 16
Global Const TileH = 16

Global tick As Long

Global clipdata() As Integer
Global clipdatasizex As Integer
Global clipdatasizey As Integer
Global clipHasData As Boolean

Enum toolenum
    T_magnifier = 1
    T_selection = 2
    T_hand = 3
    t_pencil = 4
    t_dropper = 5
    T_Eraser = 6
    T_airbrush = 7
    t_bucket = 8
    T_line = 9
    t_spline = 10
    T_rectangle = 11
    T_ellipse = 12
    T_filledrectangle = 13
    T_filledellipse = 14
End Enum

Global splineInProgress As Boolean
Global curtool As toolenum

Function TilePixelColor(tileval As Integer) As Long
    Select Case tileval
    Case 0 'empty
      TilePixelColor = vbBlack
    Case -1 ' special case, for bigger special tiles
      TilePixelColor = vbMagenta
    Case 1 To 161 'normal
      TilePixelColor = RGB(192, 192, 192)
    Case 162 To 165 'Vdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 166 To 169 'Hdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 170 'flag
      TilePixelColor = vbYellow
    Case 171 'safe
      TilePixelColor = vbGreen
    Case 172 'soccer
      TilePixelColor = vbRed
    Case 173 To 175 'flyover
      TilePixelColor = vbCyan
    Case 176 To 183 'flyunderopaque
      TilePixelColor = vbCyan
    Case 184 To 190 'flyundertransparent
      TilePixelColor = vbCyan
    Case 191 To 215
      TilePixelColor = vbMagenta
    Case 216 'sasteroid1
      TilePixelColor = vbMagenta
    Case 217 'lasteroid
      TilePixelColor = vbMagenta
    Case 218 'sasteroid2
      TilePixelColor = vbMagenta
    Case 219 'starport
      TilePixelColor = vbMagenta
    Case 220 'wormhole
      TilePixelColor = vbMagenta
    Case 221 To 255
      TilePixelColor = vbMagenta
    Case Else 'invalid
      TilePixelColor = vbBlack
  End Select
End Function

Function isTileSpecial(map As frmMain, x As Integer, y As Integer)
    If Not (x < 0 Or y < 0 Or x > 1023 Or y > 1023) Then
        If map.getTile(x, y) <> 217 And map.getTile(x, y) <> 219 And _
           map.getTile(x, y) <> 220 And map.getTile(x, y) <> -1 Then
            isTileSpecial = False
        Else
            isTileSpecial = True
        End If
    End If
End Function

Function GetRED(ByVal RGBColor As Long) As Long
GetRED = RGBColor And &HFF&
End Function

'get the green value from a long
Function GetGREEN(ByVal RGBColor As Long) As Long
GetGREEN = (RGBColor And &HFF00&) \ &H100&
End Function

'get the blue value from a long
Function GetBLUE(ByVal RGBColor As Long) As Long
GetBLUE = (RGBColor And &HFF0000) \ &H10000
End Function

